﻿using Styx;
using Styx.Common;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HBProfileGenerator
{
    public class HBProfileGenerator : HBPlugin
    {
        private Settings_Main SettingsWindow;

        public override string Author { get { return "Neokil"; } }
        public override string Name { get { return "Neokil's Profile Generator"; } }
        public override Version Version { get { return System.Reflection.Assembly.GetExecutingAssembly().GetName().Version; } }
        public override string ButtonText { get { return "Settings"; } }
        public override bool WantButton { get { return true; } }

        public override void OnButtonPress()
        {
            if(SettingsWindow == null || !SettingsWindow.Visible)
            {
                SettingsWindow = new Settings_Main();
                SettingsWindow.Show();
            }
        }

        public override void Pulse()
        {
            #region Fishing Plugin

            try
            {
                if (NeokilSettings.Current.FishingPluginDeleteDublicates)
                {
                    while (StyxWoW.Me.IsResting && StyxWoW.Me.BagItems.Count(c => c.Entry == 118380 || c.Entry == 118393) > 1)
                    {
                        var item = StyxWoW.Me.BagItems.First(c => c.Entry == 118380 || c.Entry == 118393);
                        item.PickUp();
                        StyxWoW.Sleep(1000);
                        Styx.WoWInternals.Lua.DoString("DeleteCursorItem();");
                        StyxWoW.Sleep(2500);
                        Logging.Write(LogLevel.Normal, "Deleted \"Hightfish Cap\" or \"Tentacled Hat\" because we had more than one in the bag");
                    }

                    while (StyxWoW.Me.IsResting && StyxWoW.Me.BagItems.Count(c => c.Entry == 118381) > 1)
                    {
                        var item = StyxWoW.Me.BagItems.First(c => c.Entry == 118381);
                        item.PickUp();
                        StyxWoW.Sleep(1000);
                        Styx.WoWInternals.Lua.DoString("DeleteCursorItem();");
                        StyxWoW.Sleep(2500);
                        Logging.Write(LogLevel.Normal, "Deleted \"Ephemeral Fishing Pole\" because we had more than one in the bag");
                    }
                }
            }
            catch (Exception ex)
            {
                Logging.WriteException(ex);
            }

            try
            {
                if (NeokilSettings.Current.FishingPluginAutoGutAndClean)
                {
                    if (StyxWoW.Me.Combat || StyxWoW.Me.IsMoving)
                    {
                        return;
                    }

                    List<uint> fishes = new List<uint>()
                    {
                        111664, //Abyssal Gulper Eel
                        111671, //Enormous Abyssal Gulper Eel
                        111663, //Blackwater Whiptail
                        111670, //Enormous Blackwater Whiptail
                        111667, //Blind Lake Sturgeon
                        111674, //Enormous Blind Lake Sturgeon
                        111595, //Crescent Saberfish
                        111601, //Enormous Crescent Saberfish
                        111668, //Fat Sleeper
                        111675, //Enormous Fat Sleeper
                        111669, //Jawless Skulker
                        111676, //Enormous Jawless Skulker
                        111666, //Fire Ammonite
                        111673, //Enormous Fire Ammonite
                        111665, //Sea Scorpion
                        111672, //Enormous Sea Scorpion
                    };

                    foreach (uint fish in fishes)
                    {
                        if (StyxWoW.Me.GetCarriedItemCount(fish) >= 5)
                        {
                            StyxWoW.Me.BagItems.FirstOrDefault(f => f.Entry == fish).UseContainerItem();
                            Logging.Write("Found Fish to gut and clean...");
                            StyxWoW.Sleep(2500);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                Logging.WriteException(ex);
            }

            #endregion

            #region Remove Items

            while(StyxWoW.Me.BagItems.Any(a => NeokilSettings.Current.LootFilterPluginRemoveItemEntrys.Any(b => a.Entry == b)))
            {
                var item = StyxWoW.Me.BagItems.First(a => NeokilSettings.Current.LootFilterPluginRemoveItemEntrys.Any(b => a.Entry == b));
                Logging.Write("Removing " + item.Name);
                item.PickUp();
                StyxWoW.Sleep(1000);
                Styx.WoWInternals.Lua.DoString("DeleteCursorItem();");
            }

            #endregion

            #region Use Items

            while (StyxWoW.Me.BagItems.Any(a => NeokilSettings.Current.LootFilterPluginUseItemEntrys.Any(b => a.Entry == b)))
            {
                var item = StyxWoW.Me.BagItems.First(a => NeokilSettings.Current.LootFilterPluginUseItemEntrys.Any(b => a.Entry == b));
                Logging.Write("Using " + item.Name + "\n" + item.ItemInfo.Description);

                /*item.
                item.PickUp();
                StyxWoW.Sleep(1000);
                Styx.WoWInternals.Lua.DoString("DeleteCursorItem();");*/
            }

            #endregion

            #region Lumber gathering

            //Small Timber: 234080, 234126, 234122 
            //Timber: 234194, 234123
            //Large Timber: 234195, 234124

            if(StyxWoW.Me.IsResting)
            {
                List<WoWGameObject> timberList = new List<WoWGameObject>();

                if (NeokilSettings.Current.TimberGatheringPluginSmallTimber)
                {
                    timberList.AddRange(ObjectManager.GetObjectsOfType<WoWGameObject>().Where(a => a.Name == "Small Timber" && a.Distance < 75));
                }
                if (NeokilSettings.Current.TimberGatheringPluginMediumTimber)
                {
                    timberList.AddRange(ObjectManager.GetObjectsOfType<WoWGameObject>().Where(a => a.Name == "Timber" && a.Distance < 75));
                }
                if (NeokilSettings.Current.TimberGatheringPluginLargeTimber)
                {
                    timberList.AddRange(ObjectManager.GetObjectsOfType<WoWGameObject>().Where(a => a.Name == "Large Timber" && a.Distance < 75));
                }

                var target = timberList.OrderBy(o => o.Distance).FirstOrDefault();
                if(target != null)
                {
                    Logging.Write("Interacting with Timber...");
                    target.Interact();                  
                }
            }

            #endregion
        }
    }
}
