﻿using Styx.Common;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace HBProfileGenerator
{
    public class ProfileTemplate
    {
        private static List<ProfileTemplate> _All;
        public static List<ProfileTemplate> All
        {
            get
            {
                if(_All == null)
                {
                    _All = new List<ProfileTemplate>();
                }
                return _All;
            }
        }

        private String _Filename;
        public String Filename { get { return _Filename; } }

        private String _Content;
        public String Content { get { return _Content; } }

        private String _Title;
        public String Title { get { return _Title; } }

        private String _TemplateId;
        public String TemplateId { get { return _TemplateId; } }

        public ProfileTemplate(String Filename)
        {
            Logging.Write(LogLevel.Diagnostic, "ProfileTemplates(Filename) entered");

            _Filename = Filename;

            StreamReader sr = new StreamReader(Filename);
            _Content = sr.ReadToEnd();
            sr.Close();

            if (_Content.Split(new char[] { '\n' }).Any(a => a.Trim().ToLower().StartsWith("<!-- #title")))
            {
                _Title = _Content.Split(new char[] { '\n' }).First(a => a.Trim().ToLower().StartsWith("<!-- #title")).Trim().Substring("<!-- #title".Length).Replace("-->", "").Trim();
            }
            else
            {
                MessageBox.Show("Error while reading \"" + Path.GetFileName(_Filename) + "\"\nTo Template-Title was found.");
            }

            if (_Content.Split(new char[] { '\n' }).Any(a => a.Trim().ToLower().StartsWith("<!-- #id")))
            {
                _TemplateId = _Content.Split(new char[] { '\n' }).First(a => a.Trim().ToLower().StartsWith("<!-- #id")).Trim().Substring("<!-- #id".Length).Replace("-->", "").Trim();
            }
            else
            {
                MessageBox.Show("Error while reading \"" + Path.GetFileName(_Filename) + "\"\nTo Template-ID was found.");
            }

            All.Add(this);

            Logging.Write(LogLevel.Diagnostic, "ProfileTemplates(Filename) left");
        }

        public override string ToString()
        {
            return Title ?? "No Title";
        }
    }
}
