﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Reflection;
using Styx.Common;

namespace HBProfileGenerator
{
    public static class Updater
    {
        //neokil.de/Files/HBProfileGenerator/Properties/AssemblyInfo.cs
        private const String Address = "http://neokil.de/Files/HBProfileGenerator/";

        public static bool IsUpToDate
        {
            get
            {
                Logging.Write("Testing for a new version");
                return 
                    Assembly.GetExecutingAssembly().GetName().Version 
                    >= 
                    new Version(new StreamReader(HttpWebRequest.Create(Address + "version").GetResponse().GetResponseStream()).ReadToEnd());
            }
        }

        public static void UpdateClient()
        {
            var tmp = Path.GetTempFileName() + ".zip";

            Logging.Write("Starting Update");
            WebClient client = new WebClient();
            Logging.Write("Downloading filelist");
            String[] files = new StreamReader(HttpWebRequest.Create(Address + "fileslist").GetResponse().GetResponseStream()).ReadToEnd().Split(new char[] { '\n' }, StringSplitOptions.RemoveEmptyEntries);

            Logging.Write("Downloading files");
            foreach (string file in files)
            {
                try
                {
                    var localfile = Utilities.AssemblyDirectory + "\\Plugins\\HBProfileGenerator\\" + file;
                    var tempfile = Path.GetTempFileName();
                    if(File.Exists(localfile))
                    {
                        File.Delete(localfile);
                    }

                    Logging.Write(LogLevel.Diagnostic, "Downloading " + file + " to " + tempfile);
                    client.DownloadFile(Address + "files/" + file, tempfile);

                    Logging.Write(LogLevel.Diagnostic, "Moving " + tempfile + " to " + localfile);
                    File.Copy(tempfile, localfile, true);
                }
                catch (Exception ex)
                {
                    Logging.Write(LogLevel.Diagnostic, ex.Message + "\n file -> " + file + " StackTrace -> " + ex.StackTrace);
                }
            }
            Logging.Write("Updating QuestBehaviour");
            File.Copy(Utilities.AssemblyDirectory + "\\Plugins\\HBProfileGenerator\\Resources\\MrFishIt.txt", Utilities.AssemblyDirectory + "\\Quest Behaviors\\MrFishIt.cs", true);

            Logging.Write("Update done. Please restart Honorbuddy to apply it.");
        }
    }
}
